"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ClsInterceptor = void 0;
const common_1 = require("@nestjs/common");
const rxjs_1 = require("rxjs");
const cls_service_manager_1 = require("../cls-service-manager");
const cls_constants_1 = require("../cls.constants");
const cls_internal_constants_1 = require("../cls.internal-constants");
const cls_options_1 = require("../cls.options");
const cls_plugin_hooks_host_1 = require("../plugin/cls-plugin-hooks-host");
const context_cls_store_map_1 = require("./utils/context-cls-store-map");
let ClsInterceptor = class ClsInterceptor {
    constructor(options) {
        this.options = { ...new cls_options_1.ClsInterceptorOptions(), ...options };
    }
    intercept(context, next) {
        const cls = cls_service_manager_1.ClsServiceManager.getClsService();
        const clsStore = context_cls_store_map_1.ContextClsStoreMap.get(context) ?? {};
        const pluginHooks = cls_plugin_hooks_host_1.ClsPluginsHooksHost.getInstance();
        context_cls_store_map_1.ContextClsStoreMap.set(context, clsStore);
        return new rxjs_1.Observable((subscriber) => {
            cls.runWith(clsStore, async () => {
                const pluginCtx = {
                    kind: 'interceptor',
                    ctx: context,
                };
                if (this.options.initializePlugins) {
                    await pluginHooks.beforeSetup(pluginCtx);
                }
                if (this.options.generateId) {
                    const id = await this.options.idGenerator?.(context);
                    cls.setIfUndefined(cls_constants_1.CLS_ID, id);
                }
                if (this.options.saveCtx) {
                    cls.set(cls_constants_1.CLS_CTX, context);
                }
                if (this.options.setup) {
                    await this.options.setup(cls, context);
                }
                if (this.options.initializePlugins) {
                    await pluginHooks.afterSetup(pluginCtx);
                }
                if (this.options.resolveProxyProviders) {
                    await cls.proxy.resolve();
                }
                try {
                    next.handle()
                        .pipe()
                        .subscribe({
                        next: (res) => subscriber.next(res),
                        error: (err) => subscriber.error(err),
                        complete: () => subscriber.complete(),
                    });
                }
                catch (e) {
                    subscriber.error(e);
                }
            });
        });
    }
};
exports.ClsInterceptor = ClsInterceptor;
exports.ClsInterceptor = ClsInterceptor = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)(cls_internal_constants_1.CLS_INTERCEPTOR_OPTIONS)),
    __metadata("design:paramtypes", [Object])
], ClsInterceptor);
